local mod = RW:Boss("Halfus Wyrmbreaker", "The Bastion of Twilight")
local L

mod.BossIcon = [[Interface\ICONS\Achievement_Dungeon_Bastion of Twilight_Halfus Wyrmbreaker]]
mod.SubCatIcon = [[Interface\ICONS\spell_fire_twilightcano]]

---------------------------
-- Variables

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(44600)
	self:SetWin()
	
	self:RegisterAlert("Berserk", self:BerserkTimer(360))
	
	-- Malevolent Strikes
	self:RegisterAlert("mStrikes", self:TargetStackMessage(86159))
	self:RegisterAlert("tStrikesDur", self:DurTargetStackTimer(30, 86159))
	
	-- Paralysis
	self:RegisterAlert("tParalysisDur", self:DurTimer(12, 84030))
	self:RegisterAlert("wParalysis", self:Warning(84030))
	
	-- Fire Barrage
	self:RegisterAlert("tBarrageDur", self:DurTimer(10, 83706))
	self:RegisterAlert("wBarrage", self:CastWarning(83706))
	
	-- Shadow Nova
	self:RegisterAlert("tNovaCD", self:CDTimer(10, 86167))
	self:RegisterAlert("wNova", self:CastWarning(86167))
	
	-- Furious Roar
	self:RegisterAlert("tRoarCD", self:CDTimer(25, 86171))
	self:RegisterAlert("tRoarDur", self:DurTimer(7, 86171))
	self:RegisterAlert("wRoar", self:CastWarning(86171))
end

---------------------------
-- Locals
local RoarCount

---------------------------
-- Start

function mod:OnEngage(trigger)
	self:Track("Strikes", 86159, 83908, 86158, 86157)
	self:Track("Paralysis", 84030)
	self:Track("Barrage", 83706)
	self:Track("Nova", 86167, 86168, 86166, 83703)
	self:Track("Roar", 86171, 86170)

	self:Call("Berserk", "Start")
	
	RoarCount = 0
end

function mod:Strikes(event, args)
	if event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_APPLIED_DOSE" then
		self:Call("mStrikes", "Show", args.dName, args.amount or 1)
		self:Call("tStrikesDur", "Start", args.dName, args.amount or 1)
	end
end

function mod:Paralysis(event, args)
	if event == "SPELL_AURA_APPLIED" and self:CUIDFromGUID(args.dGUID) == 44600 then
		self:Call("tParalysisDur", "Start")
		self:Call("wParalysis", "Show")
	end
end

function mod:Barrage(event, args)
	if event == "SPELL_AURA_APPLIED" then
		self:Call("tBarrageDur", "Start")
		self:Call("wBarrage", "Show")
	end
end

function mod:Nova(event, args)
	if event == "SPELL_CAST_START" then
		if self:InstanceSize() == 25 then
			self:Call("tNovaCD", "Start", 8)
		else
			self:Call("tNovaCD", "Start")
		end
		self:Call("wNova", "Show")
	end
end

function mod:Roar(event, args)
	if event == "SPELL_CAST_START" then
		if RoarCount == 0 then
			self:Call("wRoar", "Show")
			self:Call("tRoarDur", "Start")
			
		elseif RoarCount == 2 then
			self:Call("tRoarCD", "Schedule", 2)
		end	

		RoarCount = RoarCount + 1
		if RoarCount == 3 then
			RoarCount = 0
		end
	end
end